package v1alpha1

// This file contains a collection of methods that can be used from go-restful to
// generate Swagger API documentation for its models. Please read this PR for more
// information on the implementation: https://github.com/emicklei/go-restful/pull/215
//
// TODOs are ignored from the parser (e.g. TODO(andronat):... || TODO:...) if and only if
// they are on one line! For multiple line or blocks that you want to ignore use ---.
// Any context after a --- is ignored.
//
// Those methods can be generated by using hack/update-swagger-docs.sh

// AUTO-GENERATED FUNCTIONS START HERE
var map_CrossGroupObjectReference = map[string]string{
	"":           "CrossGroupObjectReference is a reference to an object in the same namespace in the specified group.  It is similar to autoscaling.CrossVersionObjectReference.",
	"kind":       "Kind of the referent; More info: http://releases.k8s.io/release-1.3/docs/devel/api-conventions.md#types-kinds\"",
	"name":       "Name of the referent; More info: http://releases.k8s.io/release-1.3/docs/user-guide/identifiers.md#names",
	"apiVersion": "API version of the referent (deprecated, prefer usng Group instead)",
	"group":      "Group of the referent",
}

func (CrossGroupObjectReference) SwaggerDoc() map[string]string {
	return map_CrossGroupObjectReference
}

var map_RecordedScaleReference = map[string]string{
	"":         "RecordedScaleReference is a CrossGroupObjectReference to a scale subresource that also has the previous replica count recorded",
	"replicas": "The last seen scale of the idled resource (before idling)",
}

func (RecordedScaleReference) SwaggerDoc() map[string]string {
	return map_RecordedScaleReference
}

// AUTO-GENERATED FUNCTIONS END HERE
