// Code generated by applyconfiguration-gen. DO NOT EDIT.

package internal

import (
	"fmt"
	"sync"

	typed "sigs.k8s.io/structured-merge-diff/v4/typed"
)

func Parser() *typed.Parser {
	parserOnce.Do(func() {
		var err error
		parser, err = typed.NewParser(schemaYAML)
		if err != nil {
			panic(fmt.Sprintf("Failed to parse schema: %v", err))
		}
	})
	return parser
}

var parserOnce sync.Once
var parser *typed.Parser
var schemaYAML = typed.YAMLObject(`types:
- name: com.github.openshift.api.build.v1.BinaryBuildSource
  map:
    fields:
    - name: asFile
      type:
        scalar: string
- name: com.github.openshift.api.build.v1.BitbucketWebHookCause
  map:
    fields:
    - name: revision
      type:
        namedType: com.github.openshift.api.build.v1.SourceRevision
    - name: secret
      type:
        scalar: string
- name: com.github.openshift.api.build.v1.Build
  map:
    fields:
    - name: apiVersion
      type:
        scalar: string
    - name: kind
      type:
        scalar: string
    - name: metadata
      type:
        namedType: io.k8s.apimachinery.pkg.apis.meta.v1.ObjectMeta
      default: {}
    - name: spec
      type:
        namedType: com.github.openshift.api.build.v1.BuildSpec
      default: {}
    - name: status
      type:
        namedType: com.github.openshift.api.build.v1.BuildStatus
      default: {}
- name: com.github.openshift.api.build.v1.BuildCondition
  map:
    fields:
    - name: lastTransitionTime
      type:
        namedType: io.k8s.apimachinery.pkg.apis.meta.v1.Time
    - name: lastUpdateTime
      type:
        namedType: io.k8s.apimachinery.pkg.apis.meta.v1.Time
    - name: message
      type:
        scalar: string
    - name: reason
      type:
        scalar: string
    - name: status
      type:
        scalar: string
      default: ""
    - name: type
      type:
        scalar: string
      default: ""
- name: com.github.openshift.api.build.v1.BuildConfig
  map:
    fields:
    - name: apiVersion
      type:
        scalar: string
    - name: kind
      type:
        scalar: string
    - name: metadata
      type:
        namedType: io.k8s.apimachinery.pkg.apis.meta.v1.ObjectMeta
      default: {}
    - name: spec
      type:
        namedType: com.github.openshift.api.build.v1.BuildConfigSpec
      default: {}
    - name: status
      type:
        namedType: com.github.openshift.api.build.v1.BuildConfigStatus
      default: {}
- name: com.github.openshift.api.build.v1.BuildConfigSpec
  map:
    fields:
    - name: completionDeadlineSeconds
      type:
        scalar: numeric
    - name: failedBuildsHistoryLimit
      type:
        scalar: numeric
    - name: mountTrustedCA
      type:
        scalar: boolean
    - name: nodeSelector
      type:
        map:
          elementType:
            scalar: string
    - name: output
      type:
        namedType: com.github.openshift.api.build.v1.BuildOutput
      default: {}
    - name: postCommit
      type:
        namedType: com.github.openshift.api.build.v1.BuildPostCommitSpec
      default: {}
    - name: resources
      type:
        namedType: io.k8s.api.core.v1.ResourceRequirements
      default: {}
    - name: revision
      type:
        namedType: com.github.openshift.api.build.v1.SourceRevision
    - name: runPolicy
      type:
        scalar: string
    - name: serviceAccount
      type:
        scalar: string
    - name: source
      type:
        namedType: com.github.openshift.api.build.v1.BuildSource
      default: {}
    - name: strategy
      type:
        namedType: com.github.openshift.api.build.v1.BuildStrategy
      default: {}
    - name: successfulBuildsHistoryLimit
      type:
        scalar: numeric
    - name: triggers
      type:
        list:
          elementType:
            namedType: com.github.openshift.api.build.v1.BuildTriggerPolicy
          elementRelationship: atomic
- name: com.github.openshift.api.build.v1.BuildConfigStatus
  map:
    fields:
    - name: imageChangeTriggers
      type:
        list:
          elementType:
            namedType: com.github.openshift.api.build.v1.ImageChangeTriggerStatus
          elementRelationship: atomic
    - name: lastVersion
      type:
        scalar: numeric
      default: 0
- name: com.github.openshift.api.build.v1.BuildOutput
  map:
    fields:
    - name: imageLabels
      type:
        list:
          elementType:
            namedType: com.github.openshift.api.build.v1.ImageLabel
          elementRelationship: atomic
    - name: pushSecret
      type:
        namedType: io.k8s.api.core.v1.LocalObjectReference
    - name: to
      type:
        namedType: io.k8s.api.core.v1.ObjectReference
- name: com.github.openshift.api.build.v1.BuildPostCommitSpec
  map:
    fields:
    - name: args
      type:
        list:
          elementType:
            scalar: string
          elementRelationship: atomic
    - name: command
      type:
        list:
          elementType:
            scalar: string
          elementRelationship: atomic
    - name: script
      type:
        scalar: string
- name: com.github.openshift.api.build.v1.BuildSource
  map:
    fields:
    - name: binary
      type:
        namedType: com.github.openshift.api.build.v1.BinaryBuildSource
    - name: configMaps
      type:
        list:
          elementType:
            namedType: com.github.openshift.api.build.v1.ConfigMapBuildSource
          elementRelationship: atomic
    - name: contextDir
      type:
        scalar: string
    - name: dockerfile
      type:
        scalar: string
    - name: git
      type:
        namedType: com.github.openshift.api.build.v1.GitBuildSource
    - name: images
      type:
        list:
          elementType:
            namedType: com.github.openshift.api.build.v1.ImageSource
          elementRelationship: atomic
    - name: secrets
      type:
        list:
          elementType:
            namedType: com.github.openshift.api.build.v1.SecretBuildSource
          elementRelationship: atomic
    - name: sourceSecret
      type:
        namedType: io.k8s.api.core.v1.LocalObjectReference
    - name: type
      type:
        scalar: string
- name: com.github.openshift.api.build.v1.BuildSpec
  map:
    fields:
    - name: completionDeadlineSeconds
      type:
        scalar: numeric
    - name: mountTrustedCA
      type:
        scalar: boolean
    - name: nodeSelector
      type:
        map:
          elementType:
            scalar: string
    - name: output
      type:
        namedType: com.github.openshift.api.build.v1.BuildOutput
      default: {}
    - name: postCommit
      type:
        namedType: com.github.openshift.api.build.v1.BuildPostCommitSpec
      default: {}
    - name: resources
      type:
        namedType: io.k8s.api.core.v1.ResourceRequirements
      default: {}
    - name: revision
      type:
        namedType: com.github.openshift.api.build.v1.SourceRevision
    - name: serviceAccount
      type:
        scalar: string
    - name: source
      type:
        namedType: com.github.openshift.api.build.v1.BuildSource
      default: {}
    - name: strategy
      type:
        namedType: com.github.openshift.api.build.v1.BuildStrategy
      default: {}
    - name: triggeredBy
      type:
        list:
          elementType:
            namedType: com.github.openshift.api.build.v1.BuildTriggerCause
          elementRelationship: atomic
- name: com.github.openshift.api.build.v1.BuildStatus
  map:
    fields:
    - name: cancelled
      type:
        scalar: boolean
    - name: completionTimestamp
      type:
        namedType: io.k8s.apimachinery.pkg.apis.meta.v1.Time
    - name: conditions
      type:
        list:
          elementType:
            namedType: com.github.openshift.api.build.v1.BuildCondition
          elementRelationship: associative
          keys:
          - type
    - name: config
      type:
        namedType: io.k8s.api.core.v1.ObjectReference
    - name: duration
      type:
        scalar: numeric
    - name: logSnippet
      type:
        scalar: string
    - name: message
      type:
        scalar: string
    - name: output
      type:
        namedType: com.github.openshift.api.build.v1.BuildStatusOutput
      default: {}
    - name: outputDockerImageReference
      type:
        scalar: string
    - name: phase
      type:
        scalar: string
      default: ""
    - name: reason
      type:
        scalar: string
    - name: stages
      type:
        list:
          elementType:
            namedType: com.github.openshift.api.build.v1.StageInfo
          elementRelationship: atomic
    - name: startTimestamp
      type:
        namedType: io.k8s.apimachinery.pkg.apis.meta.v1.Time
- name: com.github.openshift.api.build.v1.BuildStatusOutput
  map:
    fields:
    - name: to
      type:
        namedType: com.github.openshift.api.build.v1.BuildStatusOutputTo
- name: com.github.openshift.api.build.v1.BuildStatusOutputTo
  map:
    fields:
    - name: imageDigest
      type:
        scalar: string
- name: com.github.openshift.api.build.v1.BuildStrategy
  map:
    fields:
    - name: customStrategy
      type:
        namedType: com.github.openshift.api.build.v1.CustomBuildStrategy
    - name: dockerStrategy
      type:
        namedType: com.github.openshift.api.build.v1.DockerBuildStrategy
    - name: jenkinsPipelineStrategy
      type:
        namedType: com.github.openshift.api.build.v1.JenkinsPipelineBuildStrategy
    - name: sourceStrategy
      type:
        namedType: com.github.openshift.api.build.v1.SourceBuildStrategy
    - name: type
      type:
        scalar: string
- name: com.github.openshift.api.build.v1.BuildTriggerCause
  map:
    fields:
    - name: bitbucketWebHook
      type:
        namedType: com.github.openshift.api.build.v1.BitbucketWebHookCause
    - name: genericWebHook
      type:
        namedType: com.github.openshift.api.build.v1.GenericWebHookCause
    - name: githubWebHook
      type:
        namedType: com.github.openshift.api.build.v1.GitHubWebHookCause
    - name: gitlabWebHook
      type:
        namedType: com.github.openshift.api.build.v1.GitLabWebHookCause
    - name: imageChangeBuild
      type:
        namedType: com.github.openshift.api.build.v1.ImageChangeCause
    - name: message
      type:
        scalar: string
- name: com.github.openshift.api.build.v1.BuildTriggerPolicy
  map:
    fields:
    - name: bitbucket
      type:
        namedType: com.github.openshift.api.build.v1.WebHookTrigger
    - name: generic
      type:
        namedType: com.github.openshift.api.build.v1.WebHookTrigger
    - name: github
      type:
        namedType: com.github.openshift.api.build.v1.WebHookTrigger
    - name: gitlab
      type:
        namedType: com.github.openshift.api.build.v1.WebHookTrigger
    - name: imageChange
      type:
        namedType: com.github.openshift.api.build.v1.ImageChangeTrigger
    - name: type
      type:
        scalar: string
      default: ""
- name: com.github.openshift.api.build.v1.BuildVolume
  map:
    fields:
    - name: mounts
      type:
        list:
          elementType:
            namedType: com.github.openshift.api.build.v1.BuildVolumeMount
          elementRelationship: associative
          keys:
          - destinationPath
    - name: name
      type:
        scalar: string
      default: ""
    - name: source
      type:
        namedType: com.github.openshift.api.build.v1.BuildVolumeSource
      default: {}
- name: com.github.openshift.api.build.v1.BuildVolumeMount
  map:
    fields:
    - name: destinationPath
      type:
        scalar: string
      default: ""
- name: com.github.openshift.api.build.v1.BuildVolumeSource
  map:
    fields:
    - name: configMap
      type:
        namedType: io.k8s.api.core.v1.ConfigMapVolumeSource
    - name: csi
      type:
        namedType: io.k8s.api.core.v1.CSIVolumeSource
    - name: secret
      type:
        namedType: io.k8s.api.core.v1.SecretVolumeSource
    - name: type
      type:
        scalar: string
      default: ""
- name: com.github.openshift.api.build.v1.ConfigMapBuildSource
  map:
    fields:
    - name: configMap
      type:
        namedType: io.k8s.api.core.v1.LocalObjectReference
      default: {}
    - name: destinationDir
      type:
        scalar: string
- name: com.github.openshift.api.build.v1.CustomBuildStrategy
  map:
    fields:
    - name: buildAPIVersion
      type:
        scalar: string
    - name: env
      type:
        list:
          elementType:
            namedType: io.k8s.api.core.v1.EnvVar
          elementRelationship: atomic
    - name: exposeDockerSocket
      type:
        scalar: boolean
    - name: forcePull
      type:
        scalar: boolean
    - name: from
      type:
        namedType: io.k8s.api.core.v1.ObjectReference
      default: {}
    - name: pullSecret
      type:
        namedType: io.k8s.api.core.v1.LocalObjectReference
    - name: secrets
      type:
        list:
          elementType:
            namedType: com.github.openshift.api.build.v1.SecretSpec
          elementRelationship: atomic
- name: com.github.openshift.api.build.v1.DockerBuildStrategy
  map:
    fields:
    - name: buildArgs
      type:
        list:
          elementType:
            namedType: io.k8s.api.core.v1.EnvVar
          elementRelationship: atomic
    - name: dockerfilePath
      type:
        scalar: string
    - name: env
      type:
        list:
          elementType:
            namedType: io.k8s.api.core.v1.EnvVar
          elementRelationship: atomic
    - name: forcePull
      type:
        scalar: boolean
    - name: from
      type:
        namedType: io.k8s.api.core.v1.ObjectReference
    - name: imageOptimizationPolicy
      type:
        scalar: string
    - name: noCache
      type:
        scalar: boolean
    - name: pullSecret
      type:
        namedType: io.k8s.api.core.v1.LocalObjectReference
    - name: volumes
      type:
        list:
          elementType:
            namedType: com.github.openshift.api.build.v1.BuildVolume
          elementRelationship: associative
          keys:
          - name
- name: com.github.openshift.api.build.v1.GenericWebHookCause
  map:
    fields:
    - name: revision
      type:
        namedType: com.github.openshift.api.build.v1.SourceRevision
    - name: secret
      type:
        scalar: string
- name: com.github.openshift.api.build.v1.GitBuildSource
  map:
    fields:
    - name: httpProxy
      type:
        scalar: string
    - name: httpsProxy
      type:
        scalar: string
    - name: noProxy
      type:
        scalar: string
    - name: ref
      type:
        scalar: string
    - name: uri
      type:
        scalar: string
      default: ""
- name: com.github.openshift.api.build.v1.GitHubWebHookCause
  map:
    fields:
    - name: revision
      type:
        namedType: com.github.openshift.api.build.v1.SourceRevision
    - name: secret
      type:
        scalar: string
- name: com.github.openshift.api.build.v1.GitLabWebHookCause
  map:
    fields:
    - name: revision
      type:
        namedType: com.github.openshift.api.build.v1.SourceRevision
    - name: secret
      type:
        scalar: string
- name: com.github.openshift.api.build.v1.GitSourceRevision
  map:
    fields:
    - name: author
      type:
        namedType: com.github.openshift.api.build.v1.SourceControlUser
      default: {}
    - name: commit
      type:
        scalar: string
    - name: committer
      type:
        namedType: com.github.openshift.api.build.v1.SourceControlUser
      default: {}
    - name: message
      type:
        scalar: string
- name: com.github.openshift.api.build.v1.ImageChangeCause
  map:
    fields:
    - name: fromRef
      type:
        namedType: io.k8s.api.core.v1.ObjectReference
    - name: imageID
      type:
        scalar: string
- name: com.github.openshift.api.build.v1.ImageChangeTrigger
  map:
    fields:
    - name: from
      type:
        namedType: io.k8s.api.core.v1.ObjectReference
    - name: lastTriggeredImageID
      type:
        scalar: string
    - name: paused
      type:
        scalar: boolean
- name: com.github.openshift.api.build.v1.ImageChangeTriggerStatus
  map:
    fields:
    - name: from
      type:
        namedType: com.github.openshift.api.build.v1.ImageStreamTagReference
      default: {}
    - name: lastTriggerTime
      type:
        namedType: io.k8s.apimachinery.pkg.apis.meta.v1.Time
    - name: lastTriggeredImageID
      type:
        scalar: string
- name: com.github.openshift.api.build.v1.ImageLabel
  map:
    fields:
    - name: name
      type:
        scalar: string
      default: ""
    - name: value
      type:
        scalar: string
- name: com.github.openshift.api.build.v1.ImageSource
  map:
    fields:
    - name: as
      type:
        list:
          elementType:
            scalar: string
          elementRelationship: atomic
    - name: from
      type:
        namedType: io.k8s.api.core.v1.ObjectReference
      default: {}
    - name: paths
      type:
        list:
          elementType:
            namedType: com.github.openshift.api.build.v1.ImageSourcePath
          elementRelationship: atomic
    - name: pullSecret
      type:
        namedType: io.k8s.api.core.v1.LocalObjectReference
- name: com.github.openshift.api.build.v1.ImageSourcePath
  map:
    fields:
    - name: destinationDir
      type:
        scalar: string
      default: ""
    - name: sourcePath
      type:
        scalar: string
      default: ""
- name: com.github.openshift.api.build.v1.ImageStreamTagReference
  map:
    fields:
    - name: name
      type:
        scalar: string
    - name: namespace
      type:
        scalar: string
- name: com.github.openshift.api.build.v1.JenkinsPipelineBuildStrategy
  map:
    fields:
    - name: env
      type:
        list:
          elementType:
            namedType: io.k8s.api.core.v1.EnvVar
          elementRelationship: atomic
    - name: jenkinsfile
      type:
        scalar: string
    - name: jenkinsfilePath
      type:
        scalar: string
- name: com.github.openshift.api.build.v1.SecretBuildSource
  map:
    fields:
    - name: destinationDir
      type:
        scalar: string
    - name: secret
      type:
        namedType: io.k8s.api.core.v1.LocalObjectReference
      default: {}
- name: com.github.openshift.api.build.v1.SecretLocalReference
  map:
    fields:
    - name: name
      type:
        scalar: string
      default: ""
- name: com.github.openshift.api.build.v1.SecretSpec
  map:
    fields:
    - name: mountPath
      type:
        scalar: string
      default: ""
    - name: secretSource
      type:
        namedType: io.k8s.api.core.v1.LocalObjectReference
      default: {}
- name: com.github.openshift.api.build.v1.SourceBuildStrategy
  map:
    fields:
    - name: env
      type:
        list:
          elementType:
            namedType: io.k8s.api.core.v1.EnvVar
          elementRelationship: atomic
    - name: forcePull
      type:
        scalar: boolean
    - name: from
      type:
        namedType: io.k8s.api.core.v1.ObjectReference
      default: {}
    - name: incremental
      type:
        scalar: boolean
    - name: pullSecret
      type:
        namedType: io.k8s.api.core.v1.LocalObjectReference
    - name: scripts
      type:
        scalar: string
    - name: volumes
      type:
        list:
          elementType:
            namedType: com.github.openshift.api.build.v1.BuildVolume
          elementRelationship: associative
          keys:
          - name
- name: com.github.openshift.api.build.v1.SourceControlUser
  map:
    fields:
    - name: email
      type:
        scalar: string
    - name: name
      type:
        scalar: string
- name: com.github.openshift.api.build.v1.SourceRevision
  map:
    fields:
    - name: git
      type:
        namedType: com.github.openshift.api.build.v1.GitSourceRevision
    - name: type
      type:
        scalar: string
      default: ""
- name: com.github.openshift.api.build.v1.StageInfo
  map:
    fields:
    - name: durationMilliseconds
      type:
        scalar: numeric
    - name: name
      type:
        scalar: string
    - name: startTime
      type:
        namedType: io.k8s.apimachinery.pkg.apis.meta.v1.Time
    - name: steps
      type:
        list:
          elementType:
            namedType: com.github.openshift.api.build.v1.StepInfo
          elementRelationship: atomic
- name: com.github.openshift.api.build.v1.StepInfo
  map:
    fields:
    - name: durationMilliseconds
      type:
        scalar: numeric
    - name: name
      type:
        scalar: string
    - name: startTime
      type:
        namedType: io.k8s.apimachinery.pkg.apis.meta.v1.Time
- name: com.github.openshift.api.build.v1.WebHookTrigger
  map:
    fields:
    - name: allowEnv
      type:
        scalar: boolean
    - name: secret
      type:
        scalar: string
    - name: secretReference
      type:
        namedType: com.github.openshift.api.build.v1.SecretLocalReference
- name: io.k8s.api.core.v1.CSIVolumeSource
  map:
    fields:
    - name: driver
      type:
        scalar: string
      default: ""
    - name: fsType
      type:
        scalar: string
    - name: nodePublishSecretRef
      type:
        namedType: io.k8s.api.core.v1.LocalObjectReference
    - name: readOnly
      type:
        scalar: boolean
    - name: volumeAttributes
      type:
        map:
          elementType:
            scalar: string
- name: io.k8s.api.core.v1.ConfigMapKeySelector
  map:
    fields:
    - name: key
      type:
        scalar: string
      default: ""
    - name: name
      type:
        scalar: string
      default: ""
    - name: optional
      type:
        scalar: boolean
    elementRelationship: atomic
- name: io.k8s.api.core.v1.ConfigMapVolumeSource
  map:
    fields:
    - name: defaultMode
      type:
        scalar: numeric
    - name: items
      type:
        list:
          elementType:
            namedType: io.k8s.api.core.v1.KeyToPath
          elementRelationship: atomic
    - name: name
      type:
        scalar: string
      default: ""
    - name: optional
      type:
        scalar: boolean
- name: io.k8s.api.core.v1.EnvVar
  map:
    fields:
    - name: name
      type:
        scalar: string
      default: ""
    - name: value
      type:
        scalar: string
    - name: valueFrom
      type:
        namedType: io.k8s.api.core.v1.EnvVarSource
- name: io.k8s.api.core.v1.EnvVarSource
  map:
    fields:
    - name: configMapKeyRef
      type:
        namedType: io.k8s.api.core.v1.ConfigMapKeySelector
    - name: fieldRef
      type:
        namedType: io.k8s.api.core.v1.ObjectFieldSelector
    - name: resourceFieldRef
      type:
        namedType: io.k8s.api.core.v1.ResourceFieldSelector
    - name: secretKeyRef
      type:
        namedType: io.k8s.api.core.v1.SecretKeySelector
- name: io.k8s.api.core.v1.KeyToPath
  map:
    fields:
    - name: key
      type:
        scalar: string
      default: ""
    - name: mode
      type:
        scalar: numeric
    - name: path
      type:
        scalar: string
      default: ""
- name: io.k8s.api.core.v1.LocalObjectReference
  map:
    fields:
    - name: name
      type:
        scalar: string
      default: ""
    elementRelationship: atomic
- name: io.k8s.api.core.v1.ObjectFieldSelector
  map:
    fields:
    - name: apiVersion
      type:
        scalar: string
    - name: fieldPath
      type:
        scalar: string
      default: ""
    elementRelationship: atomic
- name: io.k8s.api.core.v1.ObjectReference
  map:
    fields:
    - name: apiVersion
      type:
        scalar: string
    - name: fieldPath
      type:
        scalar: string
    - name: kind
      type:
        scalar: string
    - name: name
      type:
        scalar: string
    - name: namespace
      type:
        scalar: string
    - name: resourceVersion
      type:
        scalar: string
    - name: uid
      type:
        scalar: string
    elementRelationship: atomic
- name: io.k8s.api.core.v1.ResourceClaim
  map:
    fields:
    - name: name
      type:
        scalar: string
      default: ""
    - name: request
      type:
        scalar: string
- name: io.k8s.api.core.v1.ResourceFieldSelector
  map:
    fields:
    - name: containerName
      type:
        scalar: string
    - name: divisor
      type:
        namedType: io.k8s.apimachinery.pkg.api.resource.Quantity
    - name: resource
      type:
        scalar: string
      default: ""
    elementRelationship: atomic
- name: io.k8s.api.core.v1.ResourceRequirements
  map:
    fields:
    - name: claims
      type:
        list:
          elementType:
            namedType: io.k8s.api.core.v1.ResourceClaim
          elementRelationship: associative
          keys:
          - name
    - name: limits
      type:
        map:
          elementType:
            namedType: io.k8s.apimachinery.pkg.api.resource.Quantity
    - name: requests
      type:
        map:
          elementType:
            namedType: io.k8s.apimachinery.pkg.api.resource.Quantity
- name: io.k8s.api.core.v1.SecretKeySelector
  map:
    fields:
    - name: key
      type:
        scalar: string
      default: ""
    - name: name
      type:
        scalar: string
      default: ""
    - name: optional
      type:
        scalar: boolean
    elementRelationship: atomic
- name: io.k8s.api.core.v1.SecretVolumeSource
  map:
    fields:
    - name: defaultMode
      type:
        scalar: numeric
    - name: items
      type:
        list:
          elementType:
            namedType: io.k8s.api.core.v1.KeyToPath
          elementRelationship: atomic
    - name: optional
      type:
        scalar: boolean
    - name: secretName
      type:
        scalar: string
- name: io.k8s.apimachinery.pkg.api.resource.Quantity
  scalar: untyped
- name: io.k8s.apimachinery.pkg.apis.meta.v1.FieldsV1
  map:
    elementType:
      scalar: untyped
      list:
        elementType:
          namedType: __untyped_atomic_
        elementRelationship: atomic
      map:
        elementType:
          namedType: __untyped_deduced_
        elementRelationship: separable
- name: io.k8s.apimachinery.pkg.apis.meta.v1.ManagedFieldsEntry
  map:
    fields:
    - name: apiVersion
      type:
        scalar: string
    - name: fieldsType
      type:
        scalar: string
    - name: fieldsV1
      type:
        namedType: io.k8s.apimachinery.pkg.apis.meta.v1.FieldsV1
    - name: manager
      type:
        scalar: string
    - name: operation
      type:
        scalar: string
    - name: subresource
      type:
        scalar: string
    - name: time
      type:
        namedType: io.k8s.apimachinery.pkg.apis.meta.v1.Time
- name: io.k8s.apimachinery.pkg.apis.meta.v1.ObjectMeta
  map:
    fields:
    - name: annotations
      type:
        map:
          elementType:
            scalar: string
    - name: creationTimestamp
      type:
        namedType: io.k8s.apimachinery.pkg.apis.meta.v1.Time
    - name: deletionGracePeriodSeconds
      type:
        scalar: numeric
    - name: deletionTimestamp
      type:
        namedType: io.k8s.apimachinery.pkg.apis.meta.v1.Time
    - name: finalizers
      type:
        list:
          elementType:
            scalar: string
          elementRelationship: associative
    - name: generateName
      type:
        scalar: string
    - name: generation
      type:
        scalar: numeric
    - name: labels
      type:
        map:
          elementType:
            scalar: string
    - name: managedFields
      type:
        list:
          elementType:
            namedType: io.k8s.apimachinery.pkg.apis.meta.v1.ManagedFieldsEntry
          elementRelationship: atomic
    - name: name
      type:
        scalar: string
    - name: namespace
      type:
        scalar: string
    - name: ownerReferences
      type:
        list:
          elementType:
            namedType: io.k8s.apimachinery.pkg.apis.meta.v1.OwnerReference
          elementRelationship: associative
          keys:
          - uid
    - name: resourceVersion
      type:
        scalar: string
    - name: selfLink
      type:
        scalar: string
    - name: uid
      type:
        scalar: string
- name: io.k8s.apimachinery.pkg.apis.meta.v1.OwnerReference
  map:
    fields:
    - name: apiVersion
      type:
        scalar: string
      default: ""
    - name: blockOwnerDeletion
      type:
        scalar: boolean
    - name: controller
      type:
        scalar: boolean
    - name: kind
      type:
        scalar: string
      default: ""
    - name: name
      type:
        scalar: string
      default: ""
    - name: uid
      type:
        scalar: string
      default: ""
    elementRelationship: atomic
- name: io.k8s.apimachinery.pkg.apis.meta.v1.Time
  scalar: untyped
- name: __untyped_atomic_
  scalar: untyped
  list:
    elementType:
      namedType: __untyped_atomic_
    elementRelationship: atomic
  map:
    elementType:
      namedType: __untyped_atomic_
    elementRelationship: atomic
- name: __untyped_deduced_
  scalar: untyped
  list:
    elementType:
      namedType: __untyped_atomic_
    elementRelationship: atomic
  map:
    elementType:
      namedType: __untyped_deduced_
    elementRelationship: separable
`)
