// Code generated by applyconfiguration-gen. DO NOT EDIT.

package internal

import (
	"fmt"
	"sync"

	typed "sigs.k8s.io/structured-merge-diff/v4/typed"
)

func Parser() *typed.Parser {
	parserOnce.Do(func() {
		var err error
		parser, err = typed.NewParser(schemaYAML)
		if err != nil {
			panic(fmt.Sprintf("Failed to parse schema: %v", err))
		}
	})
	return parser
}

var parserOnce sync.Once
var parser *typed.Parser
var schemaYAML = typed.YAMLObject(`types:
- name: com.github.openshift.api.image.v1.Image
  map:
    fields:
    - name: apiVersion
      type:
        scalar: string
    - name: dockerImageConfig
      type:
        scalar: string
    - name: dockerImageLayers
      type:
        list:
          elementType:
            namedType: com.github.openshift.api.image.v1.ImageLayer
          elementRelationship: atomic
    - name: dockerImageManifest
      type:
        scalar: string
    - name: dockerImageManifestMediaType
      type:
        scalar: string
    - name: dockerImageManifests
      type:
        list:
          elementType:
            namedType: com.github.openshift.api.image.v1.ImageManifest
          elementRelationship: atomic
    - name: dockerImageMetadata
      type:
        namedType: __untyped_atomic_
    - name: dockerImageMetadataVersion
      type:
        scalar: string
    - name: dockerImageReference
      type:
        scalar: string
    - name: dockerImageSignatures
      type:
        list:
          elementType:
            scalar: string
          elementRelationship: atomic
    - name: kind
      type:
        scalar: string
    - name: metadata
      type:
        namedType: io.k8s.apimachinery.pkg.apis.meta.v1.ObjectMeta
      default: {}
    - name: signatures
      type:
        list:
          elementType:
            namedType: com.github.openshift.api.image.v1.ImageSignature
          elementRelationship: associative
          keys:
          - name
- name: com.github.openshift.api.image.v1.ImageLayer
  map:
    fields:
    - name: mediaType
      type:
        scalar: string
      default: ""
    - name: name
      type:
        scalar: string
      default: ""
    - name: size
      type:
        scalar: numeric
      default: 0
- name: com.github.openshift.api.image.v1.ImageLookupPolicy
  map:
    fields:
    - name: local
      type:
        scalar: boolean
      default: false
- name: com.github.openshift.api.image.v1.ImageManifest
  map:
    fields:
    - name: architecture
      type:
        scalar: string
      default: ""
    - name: digest
      type:
        scalar: string
      default: ""
    - name: manifestSize
      type:
        scalar: numeric
      default: 0
    - name: mediaType
      type:
        scalar: string
      default: ""
    - name: os
      type:
        scalar: string
      default: ""
    - name: variant
      type:
        scalar: string
- name: com.github.openshift.api.image.v1.ImageSignature
  map:
    fields:
    - name: apiVersion
      type:
        scalar: string
    - name: conditions
      type:
        list:
          elementType:
            namedType: com.github.openshift.api.image.v1.SignatureCondition
          elementRelationship: associative
          keys:
          - type
    - name: content
      type:
        scalar: string
    - name: created
      type:
        namedType: io.k8s.apimachinery.pkg.apis.meta.v1.Time
    - name: imageIdentity
      type:
        scalar: string
    - name: issuedBy
      type:
        namedType: com.github.openshift.api.image.v1.SignatureIssuer
    - name: issuedTo
      type:
        namedType: com.github.openshift.api.image.v1.SignatureSubject
    - name: kind
      type:
        scalar: string
    - name: metadata
      type:
        namedType: io.k8s.apimachinery.pkg.apis.meta.v1.ObjectMeta
      default: {}
    - name: signedClaims
      type:
        map:
          elementType:
            scalar: string
    - name: type
      type:
        scalar: string
      default: ""
- name: com.github.openshift.api.image.v1.ImageStream
  map:
    fields:
    - name: apiVersion
      type:
        scalar: string
    - name: kind
      type:
        scalar: string
    - name: metadata
      type:
        namedType: io.k8s.apimachinery.pkg.apis.meta.v1.ObjectMeta
      default: {}
    - name: spec
      type:
        namedType: com.github.openshift.api.image.v1.ImageStreamSpec
      default: {}
    - name: status
      type:
        namedType: com.github.openshift.api.image.v1.ImageStreamStatus
      default: {}
- name: com.github.openshift.api.image.v1.ImageStreamMapping
  map:
    fields:
    - name: apiVersion
      type:
        scalar: string
    - name: image
      type:
        namedType: com.github.openshift.api.image.v1.Image
      default: {}
    - name: kind
      type:
        scalar: string
    - name: metadata
      type:
        namedType: io.k8s.apimachinery.pkg.apis.meta.v1.ObjectMeta
      default: {}
    - name: tag
      type:
        scalar: string
      default: ""
- name: com.github.openshift.api.image.v1.ImageStreamSpec
  map:
    fields:
    - name: dockerImageRepository
      type:
        scalar: string
    - name: lookupPolicy
      type:
        namedType: com.github.openshift.api.image.v1.ImageLookupPolicy
      default: {}
    - name: tags
      type:
        list:
          elementType:
            namedType: com.github.openshift.api.image.v1.TagReference
          elementRelationship: associative
          keys:
          - name
- name: com.github.openshift.api.image.v1.ImageStreamStatus
  map:
    fields:
    - name: dockerImageRepository
      type:
        scalar: string
      default: ""
    - name: publicDockerImageRepository
      type:
        scalar: string
    - name: tags
      type:
        list:
          elementType:
            namedType: com.github.openshift.api.image.v1.NamedTagEventList
          elementRelationship: associative
          keys:
          - tag
- name: com.github.openshift.api.image.v1.NamedTagEventList
  map:
    fields:
    - name: conditions
      type:
        list:
          elementType:
            namedType: com.github.openshift.api.image.v1.TagEventCondition
          elementRelationship: atomic
    - name: items
      type:
        list:
          elementType:
            namedType: com.github.openshift.api.image.v1.TagEvent
          elementRelationship: atomic
    - name: tag
      type:
        scalar: string
      default: ""
- name: com.github.openshift.api.image.v1.SignatureCondition
  map:
    fields:
    - name: lastProbeTime
      type:
        namedType: io.k8s.apimachinery.pkg.apis.meta.v1.Time
    - name: lastTransitionTime
      type:
        namedType: io.k8s.apimachinery.pkg.apis.meta.v1.Time
    - name: message
      type:
        scalar: string
    - name: reason
      type:
        scalar: string
    - name: status
      type:
        scalar: string
      default: ""
    - name: type
      type:
        scalar: string
      default: ""
- name: com.github.openshift.api.image.v1.SignatureIssuer
  map:
    fields:
    - name: commonName
      type:
        scalar: string
    - name: organization
      type:
        scalar: string
- name: com.github.openshift.api.image.v1.SignatureSubject
  map:
    fields:
    - name: commonName
      type:
        scalar: string
    - name: organization
      type:
        scalar: string
    - name: publicKeyID
      type:
        scalar: string
      default: ""
- name: com.github.openshift.api.image.v1.TagEvent
  map:
    fields:
    - name: created
      type:
        namedType: io.k8s.apimachinery.pkg.apis.meta.v1.Time
    - name: dockerImageReference
      type:
        scalar: string
      default: ""
    - name: generation
      type:
        scalar: numeric
      default: 0
    - name: image
      type:
        scalar: string
      default: ""
- name: com.github.openshift.api.image.v1.TagEventCondition
  map:
    fields:
    - name: generation
      type:
        scalar: numeric
      default: 0
    - name: lastTransitionTime
      type:
        namedType: io.k8s.apimachinery.pkg.apis.meta.v1.Time
    - name: message
      type:
        scalar: string
    - name: reason
      type:
        scalar: string
    - name: status
      type:
        scalar: string
      default: ""
    - name: type
      type:
        scalar: string
      default: ""
- name: com.github.openshift.api.image.v1.TagImportPolicy
  map:
    fields:
    - name: importMode
      type:
        scalar: string
    - name: insecure
      type:
        scalar: boolean
    - name: scheduled
      type:
        scalar: boolean
- name: com.github.openshift.api.image.v1.TagReference
  map:
    fields:
    - name: annotations
      type:
        map:
          elementType:
            scalar: string
    - name: from
      type:
        namedType: io.k8s.api.core.v1.ObjectReference
    - name: generation
      type:
        scalar: numeric
    - name: importPolicy
      type:
        namedType: com.github.openshift.api.image.v1.TagImportPolicy
      default: {}
    - name: name
      type:
        scalar: string
      default: ""
    - name: reference
      type:
        scalar: boolean
    - name: referencePolicy
      type:
        namedType: com.github.openshift.api.image.v1.TagReferencePolicy
      default: {}
- name: com.github.openshift.api.image.v1.TagReferencePolicy
  map:
    fields:
    - name: type
      type:
        scalar: string
      default: ""
- name: io.k8s.api.core.v1.ObjectReference
  map:
    fields:
    - name: apiVersion
      type:
        scalar: string
    - name: fieldPath
      type:
        scalar: string
    - name: kind
      type:
        scalar: string
    - name: name
      type:
        scalar: string
    - name: namespace
      type:
        scalar: string
    - name: resourceVersion
      type:
        scalar: string
    - name: uid
      type:
        scalar: string
    elementRelationship: atomic
- name: io.k8s.apimachinery.pkg.apis.meta.v1.FieldsV1
  map:
    elementType:
      scalar: untyped
      list:
        elementType:
          namedType: __untyped_atomic_
        elementRelationship: atomic
      map:
        elementType:
          namedType: __untyped_deduced_
        elementRelationship: separable
- name: io.k8s.apimachinery.pkg.apis.meta.v1.ManagedFieldsEntry
  map:
    fields:
    - name: apiVersion
      type:
        scalar: string
    - name: fieldsType
      type:
        scalar: string
    - name: fieldsV1
      type:
        namedType: io.k8s.apimachinery.pkg.apis.meta.v1.FieldsV1
    - name: manager
      type:
        scalar: string
    - name: operation
      type:
        scalar: string
    - name: subresource
      type:
        scalar: string
    - name: time
      type:
        namedType: io.k8s.apimachinery.pkg.apis.meta.v1.Time
- name: io.k8s.apimachinery.pkg.apis.meta.v1.ObjectMeta
  map:
    fields:
    - name: annotations
      type:
        map:
          elementType:
            scalar: string
    - name: creationTimestamp
      type:
        namedType: io.k8s.apimachinery.pkg.apis.meta.v1.Time
    - name: deletionGracePeriodSeconds
      type:
        scalar: numeric
    - name: deletionTimestamp
      type:
        namedType: io.k8s.apimachinery.pkg.apis.meta.v1.Time
    - name: finalizers
      type:
        list:
          elementType:
            scalar: string
          elementRelationship: associative
    - name: generateName
      type:
        scalar: string
    - name: generation
      type:
        scalar: numeric
    - name: labels
      type:
        map:
          elementType:
            scalar: string
    - name: managedFields
      type:
        list:
          elementType:
            namedType: io.k8s.apimachinery.pkg.apis.meta.v1.ManagedFieldsEntry
          elementRelationship: atomic
    - name: name
      type:
        scalar: string
    - name: namespace
      type:
        scalar: string
    - name: ownerReferences
      type:
        list:
          elementType:
            namedType: io.k8s.apimachinery.pkg.apis.meta.v1.OwnerReference
          elementRelationship: associative
          keys:
          - uid
    - name: resourceVersion
      type:
        scalar: string
    - name: selfLink
      type:
        scalar: string
    - name: uid
      type:
        scalar: string
- name: io.k8s.apimachinery.pkg.apis.meta.v1.OwnerReference
  map:
    fields:
    - name: apiVersion
      type:
        scalar: string
      default: ""
    - name: blockOwnerDeletion
      type:
        scalar: boolean
    - name: controller
      type:
        scalar: boolean
    - name: kind
      type:
        scalar: string
      default: ""
    - name: name
      type:
        scalar: string
      default: ""
    - name: uid
      type:
        scalar: string
      default: ""
    elementRelationship: atomic
- name: io.k8s.apimachinery.pkg.apis.meta.v1.Time
  scalar: untyped
- name: io.k8s.apimachinery.pkg.runtime.RawExtension
  map:
    elementType:
      scalar: untyped
      list:
        elementType:
          namedType: __untyped_atomic_
        elementRelationship: atomic
      map:
        elementType:
          namedType: __untyped_deduced_
        elementRelationship: separable
- name: __untyped_atomic_
  scalar: untyped
  list:
    elementType:
      namedType: __untyped_atomic_
    elementRelationship: atomic
  map:
    elementType:
      namedType: __untyped_atomic_
    elementRelationship: atomic
- name: __untyped_deduced_
  scalar: untyped
  list:
    elementType:
      namedType: __untyped_atomic_
    elementRelationship: atomic
  map:
    elementType:
      namedType: __untyped_deduced_
    elementRelationship: separable
`)
