// Code generated by applyconfiguration-gen. DO NOT EDIT.

package internal

import (
	"fmt"
	"sync"

	typed "sigs.k8s.io/structured-merge-diff/v4/typed"
)

func Parser() *typed.Parser {
	parserOnce.Do(func() {
		var err error
		parser, err = typed.NewParser(schemaYAML)
		if err != nil {
			panic(fmt.Sprintf("Failed to parse schema: %v", err))
		}
	})
	return parser
}

var parserOnce sync.Once
var parser *typed.Parser
var schemaYAML = typed.YAMLObject(`types:
- name: com.github.openshift.api.network.v1.ClusterNetwork
  map:
    fields:
    - name: apiVersion
      type:
        scalar: string
    - name: clusterNetworks
      type:
        list:
          elementType:
            namedType: com.github.openshift.api.network.v1.ClusterNetworkEntry
          elementRelationship: atomic
    - name: hostsubnetlength
      type:
        scalar: numeric
    - name: kind
      type:
        scalar: string
    - name: metadata
      type:
        namedType: io.k8s.apimachinery.pkg.apis.meta.v1.ObjectMeta
      default: {}
    - name: mtu
      type:
        scalar: numeric
    - name: network
      type:
        scalar: string
    - name: pluginName
      type:
        scalar: string
    - name: serviceNetwork
      type:
        scalar: string
      default: ""
    - name: vxlanPort
      type:
        scalar: numeric
- name: com.github.openshift.api.network.v1.ClusterNetworkEntry
  map:
    fields:
    - name: CIDR
      type:
        scalar: string
      default: ""
    - name: hostSubnetLength
      type:
        scalar: numeric
      default: 0
- name: com.github.openshift.api.network.v1.EgressNetworkPolicy
  map:
    fields:
    - name: apiVersion
      type:
        scalar: string
    - name: kind
      type:
        scalar: string
    - name: metadata
      type:
        namedType: io.k8s.apimachinery.pkg.apis.meta.v1.ObjectMeta
      default: {}
    - name: spec
      type:
        namedType: com.github.openshift.api.network.v1.EgressNetworkPolicySpec
      default: {}
- name: com.github.openshift.api.network.v1.EgressNetworkPolicyPeer
  map:
    fields:
    - name: cidrSelector
      type:
        scalar: string
    - name: dnsName
      type:
        scalar: string
- name: com.github.openshift.api.network.v1.EgressNetworkPolicyRule
  map:
    fields:
    - name: to
      type:
        namedType: com.github.openshift.api.network.v1.EgressNetworkPolicyPeer
      default: {}
    - name: type
      type:
        scalar: string
      default: ""
- name: com.github.openshift.api.network.v1.EgressNetworkPolicySpec
  map:
    fields:
    - name: egress
      type:
        list:
          elementType:
            namedType: com.github.openshift.api.network.v1.EgressNetworkPolicyRule
          elementRelationship: atomic
- name: com.github.openshift.api.network.v1.HostSubnet
  map:
    fields:
    - name: apiVersion
      type:
        scalar: string
    - name: egressCIDRs
      type:
        list:
          elementType:
            scalar: string
          elementRelationship: atomic
    - name: egressIPs
      type:
        list:
          elementType:
            scalar: string
          elementRelationship: atomic
    - name: host
      type:
        scalar: string
      default: ""
    - name: hostIP
      type:
        scalar: string
      default: ""
    - name: kind
      type:
        scalar: string
    - name: metadata
      type:
        namedType: io.k8s.apimachinery.pkg.apis.meta.v1.ObjectMeta
      default: {}
    - name: subnet
      type:
        scalar: string
      default: ""
- name: com.github.openshift.api.network.v1.NetNamespace
  map:
    fields:
    - name: apiVersion
      type:
        scalar: string
    - name: egressIPs
      type:
        list:
          elementType:
            scalar: string
          elementRelationship: atomic
    - name: kind
      type:
        scalar: string
    - name: metadata
      type:
        namedType: io.k8s.apimachinery.pkg.apis.meta.v1.ObjectMeta
      default: {}
    - name: netid
      type:
        scalar: numeric
      default: 0
    - name: netname
      type:
        scalar: string
      default: ""
- name: com.github.openshift.api.network.v1alpha1.DNSNameResolver
  map:
    fields:
    - name: apiVersion
      type:
        scalar: string
    - name: kind
      type:
        scalar: string
    - name: metadata
      type:
        namedType: io.k8s.apimachinery.pkg.apis.meta.v1.ObjectMeta
      default: {}
    - name: spec
      type:
        namedType: com.github.openshift.api.network.v1alpha1.DNSNameResolverSpec
      default: {}
    - name: status
      type:
        namedType: com.github.openshift.api.network.v1alpha1.DNSNameResolverStatus
      default: {}
- name: com.github.openshift.api.network.v1alpha1.DNSNameResolverResolvedAddress
  map:
    fields:
    - name: ip
      type:
        scalar: string
      default: ""
    - name: lastLookupTime
      type:
        namedType: io.k8s.apimachinery.pkg.apis.meta.v1.Time
    - name: ttlSeconds
      type:
        scalar: numeric
      default: 0
- name: com.github.openshift.api.network.v1alpha1.DNSNameResolverResolvedName
  map:
    fields:
    - name: conditions
      type:
        list:
          elementType:
            namedType: io.k8s.apimachinery.pkg.apis.meta.v1.Condition
          elementRelationship: associative
          keys:
          - type
    - name: dnsName
      type:
        scalar: string
      default: ""
    - name: resolutionFailures
      type:
        scalar: numeric
    - name: resolvedAddresses
      type:
        list:
          elementType:
            namedType: com.github.openshift.api.network.v1alpha1.DNSNameResolverResolvedAddress
          elementRelationship: associative
          keys:
          - ip
- name: com.github.openshift.api.network.v1alpha1.DNSNameResolverSpec
  map:
    fields:
    - name: name
      type:
        scalar: string
      default: ""
- name: com.github.openshift.api.network.v1alpha1.DNSNameResolverStatus
  map:
    fields:
    - name: resolvedNames
      type:
        list:
          elementType:
            namedType: com.github.openshift.api.network.v1alpha1.DNSNameResolverResolvedName
          elementRelationship: associative
          keys:
          - dnsName
- name: io.k8s.apimachinery.pkg.apis.meta.v1.Condition
  map:
    fields:
    - name: lastTransitionTime
      type:
        namedType: io.k8s.apimachinery.pkg.apis.meta.v1.Time
    - name: message
      type:
        scalar: string
      default: ""
    - name: observedGeneration
      type:
        scalar: numeric
    - name: reason
      type:
        scalar: string
      default: ""
    - name: status
      type:
        scalar: string
      default: ""
    - name: type
      type:
        scalar: string
      default: ""
- name: io.k8s.apimachinery.pkg.apis.meta.v1.FieldsV1
  map:
    elementType:
      scalar: untyped
      list:
        elementType:
          namedType: __untyped_atomic_
        elementRelationship: atomic
      map:
        elementType:
          namedType: __untyped_deduced_
        elementRelationship: separable
- name: io.k8s.apimachinery.pkg.apis.meta.v1.ManagedFieldsEntry
  map:
    fields:
    - name: apiVersion
      type:
        scalar: string
    - name: fieldsType
      type:
        scalar: string
    - name: fieldsV1
      type:
        namedType: io.k8s.apimachinery.pkg.apis.meta.v1.FieldsV1
    - name: manager
      type:
        scalar: string
    - name: operation
      type:
        scalar: string
    - name: subresource
      type:
        scalar: string
    - name: time
      type:
        namedType: io.k8s.apimachinery.pkg.apis.meta.v1.Time
- name: io.k8s.apimachinery.pkg.apis.meta.v1.ObjectMeta
  map:
    fields:
    - name: annotations
      type:
        map:
          elementType:
            scalar: string
    - name: creationTimestamp
      type:
        namedType: io.k8s.apimachinery.pkg.apis.meta.v1.Time
    - name: deletionGracePeriodSeconds
      type:
        scalar: numeric
    - name: deletionTimestamp
      type:
        namedType: io.k8s.apimachinery.pkg.apis.meta.v1.Time
    - name: finalizers
      type:
        list:
          elementType:
            scalar: string
          elementRelationship: associative
    - name: generateName
      type:
        scalar: string
    - name: generation
      type:
        scalar: numeric
    - name: labels
      type:
        map:
          elementType:
            scalar: string
    - name: managedFields
      type:
        list:
          elementType:
            namedType: io.k8s.apimachinery.pkg.apis.meta.v1.ManagedFieldsEntry
          elementRelationship: atomic
    - name: name
      type:
        scalar: string
    - name: namespace
      type:
        scalar: string
    - name: ownerReferences
      type:
        list:
          elementType:
            namedType: io.k8s.apimachinery.pkg.apis.meta.v1.OwnerReference
          elementRelationship: associative
          keys:
          - uid
    - name: resourceVersion
      type:
        scalar: string
    - name: selfLink
      type:
        scalar: string
    - name: uid
      type:
        scalar: string
- name: io.k8s.apimachinery.pkg.apis.meta.v1.OwnerReference
  map:
    fields:
    - name: apiVersion
      type:
        scalar: string
      default: ""
    - name: blockOwnerDeletion
      type:
        scalar: boolean
    - name: controller
      type:
        scalar: boolean
    - name: kind
      type:
        scalar: string
      default: ""
    - name: name
      type:
        scalar: string
      default: ""
    - name: uid
      type:
        scalar: string
      default: ""
    elementRelationship: atomic
- name: io.k8s.apimachinery.pkg.apis.meta.v1.Time
  scalar: untyped
- name: __untyped_atomic_
  scalar: untyped
  list:
    elementType:
      namedType: __untyped_atomic_
    elementRelationship: atomic
  map:
    elementType:
      namedType: __untyped_atomic_
    elementRelationship: atomic
- name: __untyped_deduced_
  scalar: untyped
  list:
    elementType:
      namedType: __untyped_atomic_
    elementRelationship: atomic
  map:
    elementType:
      namedType: __untyped_deduced_
    elementRelationship: separable
`)
