// Code generated by applyconfiguration-gen. DO NOT EDIT.

package v1

import (
	oauthv1 "github.com/openshift/api/oauth/v1"
	internal "github.com/openshift/client-go/oauth/applyconfigurations/internal"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	managedfields "k8s.io/apimachinery/pkg/util/managedfields"
	v1 "k8s.io/client-go/applyconfigurations/meta/v1"
)

// OAuthAuthorizeTokenApplyConfiguration represents a declarative configuration of the OAuthAuthorizeToken type for use
// with apply.
type OAuthAuthorizeTokenApplyConfiguration struct {
	v1.TypeMetaApplyConfiguration    `json:",inline"`
	*v1.ObjectMetaApplyConfiguration `json:"metadata,omitempty"`
	ClientName                       *string  `json:"clientName,omitempty"`
	ExpiresIn                        *int64   `json:"expiresIn,omitempty"`
	Scopes                           []string `json:"scopes,omitempty"`
	RedirectURI                      *string  `json:"redirectURI,omitempty"`
	State                            *string  `json:"state,omitempty"`
	UserName                         *string  `json:"userName,omitempty"`
	UserUID                          *string  `json:"userUID,omitempty"`
	CodeChallenge                    *string  `json:"codeChallenge,omitempty"`
	CodeChallengeMethod              *string  `json:"codeChallengeMethod,omitempty"`
}

// OAuthAuthorizeToken constructs a declarative configuration of the OAuthAuthorizeToken type for use with
// apply.
func OAuthAuthorizeToken(name string) *OAuthAuthorizeTokenApplyConfiguration {
	b := &OAuthAuthorizeTokenApplyConfiguration{}
	b.WithName(name)
	b.WithKind("OAuthAuthorizeToken")
	b.WithAPIVersion("oauth.openshift.io/v1")
	return b
}

// ExtractOAuthAuthorizeToken extracts the applied configuration owned by fieldManager from
// oAuthAuthorizeToken. If no managedFields are found in oAuthAuthorizeToken for fieldManager, a
// OAuthAuthorizeTokenApplyConfiguration is returned with only the Name, Namespace (if applicable),
// APIVersion and Kind populated. It is possible that no managed fields were found for because other
// field managers have taken ownership of all the fields previously owned by fieldManager, or because
// the fieldManager never owned fields any fields.
// oAuthAuthorizeToken must be a unmodified OAuthAuthorizeToken API object that was retrieved from the Kubernetes API.
// ExtractOAuthAuthorizeToken provides a way to perform a extract/modify-in-place/apply workflow.
// Note that an extracted apply configuration will contain fewer fields than what the fieldManager previously
// applied if another fieldManager has updated or force applied any of the previously applied fields.
// Experimental!
func ExtractOAuthAuthorizeToken(oAuthAuthorizeToken *oauthv1.OAuthAuthorizeToken, fieldManager string) (*OAuthAuthorizeTokenApplyConfiguration, error) {
	return extractOAuthAuthorizeToken(oAuthAuthorizeToken, fieldManager, "")
}

// ExtractOAuthAuthorizeTokenStatus is the same as ExtractOAuthAuthorizeToken except
// that it extracts the status subresource applied configuration.
// Experimental!
func ExtractOAuthAuthorizeTokenStatus(oAuthAuthorizeToken *oauthv1.OAuthAuthorizeToken, fieldManager string) (*OAuthAuthorizeTokenApplyConfiguration, error) {
	return extractOAuthAuthorizeToken(oAuthAuthorizeToken, fieldManager, "status")
}

func extractOAuthAuthorizeToken(oAuthAuthorizeToken *oauthv1.OAuthAuthorizeToken, fieldManager string, subresource string) (*OAuthAuthorizeTokenApplyConfiguration, error) {
	b := &OAuthAuthorizeTokenApplyConfiguration{}
	err := managedfields.ExtractInto(oAuthAuthorizeToken, internal.Parser().Type("com.github.openshift.api.oauth.v1.OAuthAuthorizeToken"), fieldManager, b, subresource)
	if err != nil {
		return nil, err
	}
	b.WithName(oAuthAuthorizeToken.Name)

	b.WithKind("OAuthAuthorizeToken")
	b.WithAPIVersion("oauth.openshift.io/v1")
	return b, nil
}

// WithKind sets the Kind field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Kind field is set to the value of the last call.
func (b *OAuthAuthorizeTokenApplyConfiguration) WithKind(value string) *OAuthAuthorizeTokenApplyConfiguration {
	b.Kind = &value
	return b
}

// WithAPIVersion sets the APIVersion field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the APIVersion field is set to the value of the last call.
func (b *OAuthAuthorizeTokenApplyConfiguration) WithAPIVersion(value string) *OAuthAuthorizeTokenApplyConfiguration {
	b.APIVersion = &value
	return b
}

// WithName sets the Name field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Name field is set to the value of the last call.
func (b *OAuthAuthorizeTokenApplyConfiguration) WithName(value string) *OAuthAuthorizeTokenApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	b.Name = &value
	return b
}

// WithGenerateName sets the GenerateName field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the GenerateName field is set to the value of the last call.
func (b *OAuthAuthorizeTokenApplyConfiguration) WithGenerateName(value string) *OAuthAuthorizeTokenApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	b.GenerateName = &value
	return b
}

// WithNamespace sets the Namespace field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Namespace field is set to the value of the last call.
func (b *OAuthAuthorizeTokenApplyConfiguration) WithNamespace(value string) *OAuthAuthorizeTokenApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	b.Namespace = &value
	return b
}

// WithUID sets the UID field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the UID field is set to the value of the last call.
func (b *OAuthAuthorizeTokenApplyConfiguration) WithUID(value types.UID) *OAuthAuthorizeTokenApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	b.UID = &value
	return b
}

// WithResourceVersion sets the ResourceVersion field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the ResourceVersion field is set to the value of the last call.
func (b *OAuthAuthorizeTokenApplyConfiguration) WithResourceVersion(value string) *OAuthAuthorizeTokenApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	b.ResourceVersion = &value
	return b
}

// WithGeneration sets the Generation field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Generation field is set to the value of the last call.
func (b *OAuthAuthorizeTokenApplyConfiguration) WithGeneration(value int64) *OAuthAuthorizeTokenApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	b.Generation = &value
	return b
}

// WithCreationTimestamp sets the CreationTimestamp field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the CreationTimestamp field is set to the value of the last call.
func (b *OAuthAuthorizeTokenApplyConfiguration) WithCreationTimestamp(value metav1.Time) *OAuthAuthorizeTokenApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	b.CreationTimestamp = &value
	return b
}

// WithDeletionTimestamp sets the DeletionTimestamp field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the DeletionTimestamp field is set to the value of the last call.
func (b *OAuthAuthorizeTokenApplyConfiguration) WithDeletionTimestamp(value metav1.Time) *OAuthAuthorizeTokenApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	b.DeletionTimestamp = &value
	return b
}

// WithDeletionGracePeriodSeconds sets the DeletionGracePeriodSeconds field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the DeletionGracePeriodSeconds field is set to the value of the last call.
func (b *OAuthAuthorizeTokenApplyConfiguration) WithDeletionGracePeriodSeconds(value int64) *OAuthAuthorizeTokenApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	b.DeletionGracePeriodSeconds = &value
	return b
}

// WithLabels puts the entries into the Labels field in the declarative configuration
// and returns the receiver, so that objects can be build by chaining "With" function invocations.
// If called multiple times, the entries provided by each call will be put on the Labels field,
// overwriting an existing map entries in Labels field with the same key.
func (b *OAuthAuthorizeTokenApplyConfiguration) WithLabels(entries map[string]string) *OAuthAuthorizeTokenApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	if b.Labels == nil && len(entries) > 0 {
		b.Labels = make(map[string]string, len(entries))
	}
	for k, v := range entries {
		b.Labels[k] = v
	}
	return b
}

// WithAnnotations puts the entries into the Annotations field in the declarative configuration
// and returns the receiver, so that objects can be build by chaining "With" function invocations.
// If called multiple times, the entries provided by each call will be put on the Annotations field,
// overwriting an existing map entries in Annotations field with the same key.
func (b *OAuthAuthorizeTokenApplyConfiguration) WithAnnotations(entries map[string]string) *OAuthAuthorizeTokenApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	if b.Annotations == nil && len(entries) > 0 {
		b.Annotations = make(map[string]string, len(entries))
	}
	for k, v := range entries {
		b.Annotations[k] = v
	}
	return b
}

// WithOwnerReferences adds the given value to the OwnerReferences field in the declarative configuration
// and returns the receiver, so that objects can be build by chaining "With" function invocations.
// If called multiple times, values provided by each call will be appended to the OwnerReferences field.
func (b *OAuthAuthorizeTokenApplyConfiguration) WithOwnerReferences(values ...*v1.OwnerReferenceApplyConfiguration) *OAuthAuthorizeTokenApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	for i := range values {
		if values[i] == nil {
			panic("nil value passed to WithOwnerReferences")
		}
		b.OwnerReferences = append(b.OwnerReferences, *values[i])
	}
	return b
}

// WithFinalizers adds the given value to the Finalizers field in the declarative configuration
// and returns the receiver, so that objects can be build by chaining "With" function invocations.
// If called multiple times, values provided by each call will be appended to the Finalizers field.
func (b *OAuthAuthorizeTokenApplyConfiguration) WithFinalizers(values ...string) *OAuthAuthorizeTokenApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	for i := range values {
		b.Finalizers = append(b.Finalizers, values[i])
	}
	return b
}

func (b *OAuthAuthorizeTokenApplyConfiguration) ensureObjectMetaApplyConfigurationExists() {
	if b.ObjectMetaApplyConfiguration == nil {
		b.ObjectMetaApplyConfiguration = &v1.ObjectMetaApplyConfiguration{}
	}
}

// WithClientName sets the ClientName field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the ClientName field is set to the value of the last call.
func (b *OAuthAuthorizeTokenApplyConfiguration) WithClientName(value string) *OAuthAuthorizeTokenApplyConfiguration {
	b.ClientName = &value
	return b
}

// WithExpiresIn sets the ExpiresIn field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the ExpiresIn field is set to the value of the last call.
func (b *OAuthAuthorizeTokenApplyConfiguration) WithExpiresIn(value int64) *OAuthAuthorizeTokenApplyConfiguration {
	b.ExpiresIn = &value
	return b
}

// WithScopes adds the given value to the Scopes field in the declarative configuration
// and returns the receiver, so that objects can be build by chaining "With" function invocations.
// If called multiple times, values provided by each call will be appended to the Scopes field.
func (b *OAuthAuthorizeTokenApplyConfiguration) WithScopes(values ...string) *OAuthAuthorizeTokenApplyConfiguration {
	for i := range values {
		b.Scopes = append(b.Scopes, values[i])
	}
	return b
}

// WithRedirectURI sets the RedirectURI field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the RedirectURI field is set to the value of the last call.
func (b *OAuthAuthorizeTokenApplyConfiguration) WithRedirectURI(value string) *OAuthAuthorizeTokenApplyConfiguration {
	b.RedirectURI = &value
	return b
}

// WithState sets the State field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the State field is set to the value of the last call.
func (b *OAuthAuthorizeTokenApplyConfiguration) WithState(value string) *OAuthAuthorizeTokenApplyConfiguration {
	b.State = &value
	return b
}

// WithUserName sets the UserName field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the UserName field is set to the value of the last call.
func (b *OAuthAuthorizeTokenApplyConfiguration) WithUserName(value string) *OAuthAuthorizeTokenApplyConfiguration {
	b.UserName = &value
	return b
}

// WithUserUID sets the UserUID field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the UserUID field is set to the value of the last call.
func (b *OAuthAuthorizeTokenApplyConfiguration) WithUserUID(value string) *OAuthAuthorizeTokenApplyConfiguration {
	b.UserUID = &value
	return b
}

// WithCodeChallenge sets the CodeChallenge field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the CodeChallenge field is set to the value of the last call.
func (b *OAuthAuthorizeTokenApplyConfiguration) WithCodeChallenge(value string) *OAuthAuthorizeTokenApplyConfiguration {
	b.CodeChallenge = &value
	return b
}

// WithCodeChallengeMethod sets the CodeChallengeMethod field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the CodeChallengeMethod field is set to the value of the last call.
func (b *OAuthAuthorizeTokenApplyConfiguration) WithCodeChallengeMethod(value string) *OAuthAuthorizeTokenApplyConfiguration {
	b.CodeChallengeMethod = &value
	return b
}

// GetName retrieves the value of the Name field in the declarative configuration.
func (b *OAuthAuthorizeTokenApplyConfiguration) GetName() *string {
	b.ensureObjectMetaApplyConfigurationExists()
	return b.Name
}
