// Code generated by applyconfiguration-gen. DO NOT EDIT.

package v1

import (
	projectv1 "github.com/openshift/api/project/v1"
	internal "github.com/openshift/client-go/project/applyconfigurations/internal"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	managedfields "k8s.io/apimachinery/pkg/util/managedfields"
	v1 "k8s.io/client-go/applyconfigurations/meta/v1"
)

// ProjectRequestApplyConfiguration represents a declarative configuration of the ProjectRequest type for use
// with apply.
type ProjectRequestApplyConfiguration struct {
	v1.TypeMetaApplyConfiguration    `json:",inline"`
	*v1.ObjectMetaApplyConfiguration `json:"metadata,omitempty"`
	DisplayName                      *string `json:"displayName,omitempty"`
	Description                      *string `json:"description,omitempty"`
}

// ProjectRequest constructs a declarative configuration of the ProjectRequest type for use with
// apply.
func ProjectRequest(name string) *ProjectRequestApplyConfiguration {
	b := &ProjectRequestApplyConfiguration{}
	b.WithName(name)
	b.WithKind("ProjectRequest")
	b.WithAPIVersion("project.openshift.io/v1")
	return b
}

// ExtractProjectRequest extracts the applied configuration owned by fieldManager from
// projectRequest. If no managedFields are found in projectRequest for fieldManager, a
// ProjectRequestApplyConfiguration is returned with only the Name, Namespace (if applicable),
// APIVersion and Kind populated. It is possible that no managed fields were found for because other
// field managers have taken ownership of all the fields previously owned by fieldManager, or because
// the fieldManager never owned fields any fields.
// projectRequest must be a unmodified ProjectRequest API object that was retrieved from the Kubernetes API.
// ExtractProjectRequest provides a way to perform a extract/modify-in-place/apply workflow.
// Note that an extracted apply configuration will contain fewer fields than what the fieldManager previously
// applied if another fieldManager has updated or force applied any of the previously applied fields.
// Experimental!
func ExtractProjectRequest(projectRequest *projectv1.ProjectRequest, fieldManager string) (*ProjectRequestApplyConfiguration, error) {
	return extractProjectRequest(projectRequest, fieldManager, "")
}

// ExtractProjectRequestStatus is the same as ExtractProjectRequest except
// that it extracts the status subresource applied configuration.
// Experimental!
func ExtractProjectRequestStatus(projectRequest *projectv1.ProjectRequest, fieldManager string) (*ProjectRequestApplyConfiguration, error) {
	return extractProjectRequest(projectRequest, fieldManager, "status")
}

func extractProjectRequest(projectRequest *projectv1.ProjectRequest, fieldManager string, subresource string) (*ProjectRequestApplyConfiguration, error) {
	b := &ProjectRequestApplyConfiguration{}
	err := managedfields.ExtractInto(projectRequest, internal.Parser().Type("com.github.openshift.api.project.v1.ProjectRequest"), fieldManager, b, subresource)
	if err != nil {
		return nil, err
	}
	b.WithName(projectRequest.Name)

	b.WithKind("ProjectRequest")
	b.WithAPIVersion("project.openshift.io/v1")
	return b, nil
}

// WithKind sets the Kind field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Kind field is set to the value of the last call.
func (b *ProjectRequestApplyConfiguration) WithKind(value string) *ProjectRequestApplyConfiguration {
	b.Kind = &value
	return b
}

// WithAPIVersion sets the APIVersion field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the APIVersion field is set to the value of the last call.
func (b *ProjectRequestApplyConfiguration) WithAPIVersion(value string) *ProjectRequestApplyConfiguration {
	b.APIVersion = &value
	return b
}

// WithName sets the Name field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Name field is set to the value of the last call.
func (b *ProjectRequestApplyConfiguration) WithName(value string) *ProjectRequestApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	b.Name = &value
	return b
}

// WithGenerateName sets the GenerateName field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the GenerateName field is set to the value of the last call.
func (b *ProjectRequestApplyConfiguration) WithGenerateName(value string) *ProjectRequestApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	b.GenerateName = &value
	return b
}

// WithNamespace sets the Namespace field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Namespace field is set to the value of the last call.
func (b *ProjectRequestApplyConfiguration) WithNamespace(value string) *ProjectRequestApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	b.Namespace = &value
	return b
}

// WithUID sets the UID field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the UID field is set to the value of the last call.
func (b *ProjectRequestApplyConfiguration) WithUID(value types.UID) *ProjectRequestApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	b.UID = &value
	return b
}

// WithResourceVersion sets the ResourceVersion field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the ResourceVersion field is set to the value of the last call.
func (b *ProjectRequestApplyConfiguration) WithResourceVersion(value string) *ProjectRequestApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	b.ResourceVersion = &value
	return b
}

// WithGeneration sets the Generation field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Generation field is set to the value of the last call.
func (b *ProjectRequestApplyConfiguration) WithGeneration(value int64) *ProjectRequestApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	b.Generation = &value
	return b
}

// WithCreationTimestamp sets the CreationTimestamp field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the CreationTimestamp field is set to the value of the last call.
func (b *ProjectRequestApplyConfiguration) WithCreationTimestamp(value metav1.Time) *ProjectRequestApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	b.CreationTimestamp = &value
	return b
}

// WithDeletionTimestamp sets the DeletionTimestamp field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the DeletionTimestamp field is set to the value of the last call.
func (b *ProjectRequestApplyConfiguration) WithDeletionTimestamp(value metav1.Time) *ProjectRequestApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	b.DeletionTimestamp = &value
	return b
}

// WithDeletionGracePeriodSeconds sets the DeletionGracePeriodSeconds field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the DeletionGracePeriodSeconds field is set to the value of the last call.
func (b *ProjectRequestApplyConfiguration) WithDeletionGracePeriodSeconds(value int64) *ProjectRequestApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	b.DeletionGracePeriodSeconds = &value
	return b
}

// WithLabels puts the entries into the Labels field in the declarative configuration
// and returns the receiver, so that objects can be build by chaining "With" function invocations.
// If called multiple times, the entries provided by each call will be put on the Labels field,
// overwriting an existing map entries in Labels field with the same key.
func (b *ProjectRequestApplyConfiguration) WithLabels(entries map[string]string) *ProjectRequestApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	if b.Labels == nil && len(entries) > 0 {
		b.Labels = make(map[string]string, len(entries))
	}
	for k, v := range entries {
		b.Labels[k] = v
	}
	return b
}

// WithAnnotations puts the entries into the Annotations field in the declarative configuration
// and returns the receiver, so that objects can be build by chaining "With" function invocations.
// If called multiple times, the entries provided by each call will be put on the Annotations field,
// overwriting an existing map entries in Annotations field with the same key.
func (b *ProjectRequestApplyConfiguration) WithAnnotations(entries map[string]string) *ProjectRequestApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	if b.Annotations == nil && len(entries) > 0 {
		b.Annotations = make(map[string]string, len(entries))
	}
	for k, v := range entries {
		b.Annotations[k] = v
	}
	return b
}

// WithOwnerReferences adds the given value to the OwnerReferences field in the declarative configuration
// and returns the receiver, so that objects can be build by chaining "With" function invocations.
// If called multiple times, values provided by each call will be appended to the OwnerReferences field.
func (b *ProjectRequestApplyConfiguration) WithOwnerReferences(values ...*v1.OwnerReferenceApplyConfiguration) *ProjectRequestApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	for i := range values {
		if values[i] == nil {
			panic("nil value passed to WithOwnerReferences")
		}
		b.OwnerReferences = append(b.OwnerReferences, *values[i])
	}
	return b
}

// WithFinalizers adds the given value to the Finalizers field in the declarative configuration
// and returns the receiver, so that objects can be build by chaining "With" function invocations.
// If called multiple times, values provided by each call will be appended to the Finalizers field.
func (b *ProjectRequestApplyConfiguration) WithFinalizers(values ...string) *ProjectRequestApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	for i := range values {
		b.Finalizers = append(b.Finalizers, values[i])
	}
	return b
}

func (b *ProjectRequestApplyConfiguration) ensureObjectMetaApplyConfigurationExists() {
	if b.ObjectMetaApplyConfiguration == nil {
		b.ObjectMetaApplyConfiguration = &v1.ObjectMetaApplyConfiguration{}
	}
}

// WithDisplayName sets the DisplayName field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the DisplayName field is set to the value of the last call.
func (b *ProjectRequestApplyConfiguration) WithDisplayName(value string) *ProjectRequestApplyConfiguration {
	b.DisplayName = &value
	return b
}

// WithDescription sets the Description field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Description field is set to the value of the last call.
func (b *ProjectRequestApplyConfiguration) WithDescription(value string) *ProjectRequestApplyConfiguration {
	b.Description = &value
	return b
}

// GetName retrieves the value of the Name field in the declarative configuration.
func (b *ProjectRequestApplyConfiguration) GetName() *string {
	b.ensureObjectMetaApplyConfigurationExists()
	return b.Name
}
