// Code generated by applyconfiguration-gen. DO NOT EDIT.

package v1

import (
	apiquotav1 "github.com/openshift/api/quota/v1"
	internal "github.com/openshift/client-go/quota/applyconfigurations/internal"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	managedfields "k8s.io/apimachinery/pkg/util/managedfields"
	v1 "k8s.io/client-go/applyconfigurations/meta/v1"
)

// ClusterResourceQuotaApplyConfiguration represents a declarative configuration of the ClusterResourceQuota type for use
// with apply.
type ClusterResourceQuotaApplyConfiguration struct {
	v1.TypeMetaApplyConfiguration    `json:",inline"`
	*v1.ObjectMetaApplyConfiguration `json:"metadata,omitempty"`
	Spec                             *ClusterResourceQuotaSpecApplyConfiguration   `json:"spec,omitempty"`
	Status                           *ClusterResourceQuotaStatusApplyConfiguration `json:"status,omitempty"`
}

// ClusterResourceQuota constructs a declarative configuration of the ClusterResourceQuota type for use with
// apply.
func ClusterResourceQuota(name string) *ClusterResourceQuotaApplyConfiguration {
	b := &ClusterResourceQuotaApplyConfiguration{}
	b.WithName(name)
	b.WithKind("ClusterResourceQuota")
	b.WithAPIVersion("quota.openshift.io/v1")
	return b
}

// ExtractClusterResourceQuota extracts the applied configuration owned by fieldManager from
// clusterResourceQuota. If no managedFields are found in clusterResourceQuota for fieldManager, a
// ClusterResourceQuotaApplyConfiguration is returned with only the Name, Namespace (if applicable),
// APIVersion and Kind populated. It is possible that no managed fields were found for because other
// field managers have taken ownership of all the fields previously owned by fieldManager, or because
// the fieldManager never owned fields any fields.
// clusterResourceQuota must be a unmodified ClusterResourceQuota API object that was retrieved from the Kubernetes API.
// ExtractClusterResourceQuota provides a way to perform a extract/modify-in-place/apply workflow.
// Note that an extracted apply configuration will contain fewer fields than what the fieldManager previously
// applied if another fieldManager has updated or force applied any of the previously applied fields.
// Experimental!
func ExtractClusterResourceQuota(clusterResourceQuota *apiquotav1.ClusterResourceQuota, fieldManager string) (*ClusterResourceQuotaApplyConfiguration, error) {
	return extractClusterResourceQuota(clusterResourceQuota, fieldManager, "")
}

// ExtractClusterResourceQuotaStatus is the same as ExtractClusterResourceQuota except
// that it extracts the status subresource applied configuration.
// Experimental!
func ExtractClusterResourceQuotaStatus(clusterResourceQuota *apiquotav1.ClusterResourceQuota, fieldManager string) (*ClusterResourceQuotaApplyConfiguration, error) {
	return extractClusterResourceQuota(clusterResourceQuota, fieldManager, "status")
}

func extractClusterResourceQuota(clusterResourceQuota *apiquotav1.ClusterResourceQuota, fieldManager string, subresource string) (*ClusterResourceQuotaApplyConfiguration, error) {
	b := &ClusterResourceQuotaApplyConfiguration{}
	err := managedfields.ExtractInto(clusterResourceQuota, internal.Parser().Type("com.github.openshift.api.quota.v1.ClusterResourceQuota"), fieldManager, b, subresource)
	if err != nil {
		return nil, err
	}
	b.WithName(clusterResourceQuota.Name)

	b.WithKind("ClusterResourceQuota")
	b.WithAPIVersion("quota.openshift.io/v1")
	return b, nil
}

// WithKind sets the Kind field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Kind field is set to the value of the last call.
func (b *ClusterResourceQuotaApplyConfiguration) WithKind(value string) *ClusterResourceQuotaApplyConfiguration {
	b.Kind = &value
	return b
}

// WithAPIVersion sets the APIVersion field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the APIVersion field is set to the value of the last call.
func (b *ClusterResourceQuotaApplyConfiguration) WithAPIVersion(value string) *ClusterResourceQuotaApplyConfiguration {
	b.APIVersion = &value
	return b
}

// WithName sets the Name field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Name field is set to the value of the last call.
func (b *ClusterResourceQuotaApplyConfiguration) WithName(value string) *ClusterResourceQuotaApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	b.Name = &value
	return b
}

// WithGenerateName sets the GenerateName field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the GenerateName field is set to the value of the last call.
func (b *ClusterResourceQuotaApplyConfiguration) WithGenerateName(value string) *ClusterResourceQuotaApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	b.GenerateName = &value
	return b
}

// WithNamespace sets the Namespace field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Namespace field is set to the value of the last call.
func (b *ClusterResourceQuotaApplyConfiguration) WithNamespace(value string) *ClusterResourceQuotaApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	b.Namespace = &value
	return b
}

// WithUID sets the UID field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the UID field is set to the value of the last call.
func (b *ClusterResourceQuotaApplyConfiguration) WithUID(value types.UID) *ClusterResourceQuotaApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	b.UID = &value
	return b
}

// WithResourceVersion sets the ResourceVersion field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the ResourceVersion field is set to the value of the last call.
func (b *ClusterResourceQuotaApplyConfiguration) WithResourceVersion(value string) *ClusterResourceQuotaApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	b.ResourceVersion = &value
	return b
}

// WithGeneration sets the Generation field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Generation field is set to the value of the last call.
func (b *ClusterResourceQuotaApplyConfiguration) WithGeneration(value int64) *ClusterResourceQuotaApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	b.Generation = &value
	return b
}

// WithCreationTimestamp sets the CreationTimestamp field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the CreationTimestamp field is set to the value of the last call.
func (b *ClusterResourceQuotaApplyConfiguration) WithCreationTimestamp(value metav1.Time) *ClusterResourceQuotaApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	b.CreationTimestamp = &value
	return b
}

// WithDeletionTimestamp sets the DeletionTimestamp field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the DeletionTimestamp field is set to the value of the last call.
func (b *ClusterResourceQuotaApplyConfiguration) WithDeletionTimestamp(value metav1.Time) *ClusterResourceQuotaApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	b.DeletionTimestamp = &value
	return b
}

// WithDeletionGracePeriodSeconds sets the DeletionGracePeriodSeconds field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the DeletionGracePeriodSeconds field is set to the value of the last call.
func (b *ClusterResourceQuotaApplyConfiguration) WithDeletionGracePeriodSeconds(value int64) *ClusterResourceQuotaApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	b.DeletionGracePeriodSeconds = &value
	return b
}

// WithLabels puts the entries into the Labels field in the declarative configuration
// and returns the receiver, so that objects can be build by chaining "With" function invocations.
// If called multiple times, the entries provided by each call will be put on the Labels field,
// overwriting an existing map entries in Labels field with the same key.
func (b *ClusterResourceQuotaApplyConfiguration) WithLabels(entries map[string]string) *ClusterResourceQuotaApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	if b.Labels == nil && len(entries) > 0 {
		b.Labels = make(map[string]string, len(entries))
	}
	for k, v := range entries {
		b.Labels[k] = v
	}
	return b
}

// WithAnnotations puts the entries into the Annotations field in the declarative configuration
// and returns the receiver, so that objects can be build by chaining "With" function invocations.
// If called multiple times, the entries provided by each call will be put on the Annotations field,
// overwriting an existing map entries in Annotations field with the same key.
func (b *ClusterResourceQuotaApplyConfiguration) WithAnnotations(entries map[string]string) *ClusterResourceQuotaApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	if b.Annotations == nil && len(entries) > 0 {
		b.Annotations = make(map[string]string, len(entries))
	}
	for k, v := range entries {
		b.Annotations[k] = v
	}
	return b
}

// WithOwnerReferences adds the given value to the OwnerReferences field in the declarative configuration
// and returns the receiver, so that objects can be build by chaining "With" function invocations.
// If called multiple times, values provided by each call will be appended to the OwnerReferences field.
func (b *ClusterResourceQuotaApplyConfiguration) WithOwnerReferences(values ...*v1.OwnerReferenceApplyConfiguration) *ClusterResourceQuotaApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	for i := range values {
		if values[i] == nil {
			panic("nil value passed to WithOwnerReferences")
		}
		b.OwnerReferences = append(b.OwnerReferences, *values[i])
	}
	return b
}

// WithFinalizers adds the given value to the Finalizers field in the declarative configuration
// and returns the receiver, so that objects can be build by chaining "With" function invocations.
// If called multiple times, values provided by each call will be appended to the Finalizers field.
func (b *ClusterResourceQuotaApplyConfiguration) WithFinalizers(values ...string) *ClusterResourceQuotaApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	for i := range values {
		b.Finalizers = append(b.Finalizers, values[i])
	}
	return b
}

func (b *ClusterResourceQuotaApplyConfiguration) ensureObjectMetaApplyConfigurationExists() {
	if b.ObjectMetaApplyConfiguration == nil {
		b.ObjectMetaApplyConfiguration = &v1.ObjectMetaApplyConfiguration{}
	}
}

// WithSpec sets the Spec field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Spec field is set to the value of the last call.
func (b *ClusterResourceQuotaApplyConfiguration) WithSpec(value *ClusterResourceQuotaSpecApplyConfiguration) *ClusterResourceQuotaApplyConfiguration {
	b.Spec = value
	return b
}

// WithStatus sets the Status field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Status field is set to the value of the last call.
func (b *ClusterResourceQuotaApplyConfiguration) WithStatus(value *ClusterResourceQuotaStatusApplyConfiguration) *ClusterResourceQuotaApplyConfiguration {
	b.Status = value
	return b
}

// GetName retrieves the value of the Name field in the declarative configuration.
func (b *ClusterResourceQuotaApplyConfiguration) GetName() *string {
	b.ensureObjectMetaApplyConfigurationExists()
	return b.Name
}
