// Code generated by applyconfiguration-gen. DO NOT EDIT.

package v1

import (
	apitemplatev1 "github.com/openshift/api/template/v1"
	internal "github.com/openshift/client-go/template/applyconfigurations/internal"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	managedfields "k8s.io/apimachinery/pkg/util/managedfields"
	v1 "k8s.io/client-go/applyconfigurations/meta/v1"
)

// TemplateInstanceApplyConfiguration represents a declarative configuration of the TemplateInstance type for use
// with apply.
type TemplateInstanceApplyConfiguration struct {
	v1.TypeMetaApplyConfiguration    `json:",inline"`
	*v1.ObjectMetaApplyConfiguration `json:"metadata,omitempty"`
	Spec                             *TemplateInstanceSpecApplyConfiguration   `json:"spec,omitempty"`
	Status                           *TemplateInstanceStatusApplyConfiguration `json:"status,omitempty"`
}

// TemplateInstance constructs a declarative configuration of the TemplateInstance type for use with
// apply.
func TemplateInstance(name, namespace string) *TemplateInstanceApplyConfiguration {
	b := &TemplateInstanceApplyConfiguration{}
	b.WithName(name)
	b.WithNamespace(namespace)
	b.WithKind("TemplateInstance")
	b.WithAPIVersion("template.openshift.io/v1")
	return b
}

// ExtractTemplateInstance extracts the applied configuration owned by fieldManager from
// templateInstance. If no managedFields are found in templateInstance for fieldManager, a
// TemplateInstanceApplyConfiguration is returned with only the Name, Namespace (if applicable),
// APIVersion and Kind populated. It is possible that no managed fields were found for because other
// field managers have taken ownership of all the fields previously owned by fieldManager, or because
// the fieldManager never owned fields any fields.
// templateInstance must be a unmodified TemplateInstance API object that was retrieved from the Kubernetes API.
// ExtractTemplateInstance provides a way to perform a extract/modify-in-place/apply workflow.
// Note that an extracted apply configuration will contain fewer fields than what the fieldManager previously
// applied if another fieldManager has updated or force applied any of the previously applied fields.
// Experimental!
func ExtractTemplateInstance(templateInstance *apitemplatev1.TemplateInstance, fieldManager string) (*TemplateInstanceApplyConfiguration, error) {
	return extractTemplateInstance(templateInstance, fieldManager, "")
}

// ExtractTemplateInstanceStatus is the same as ExtractTemplateInstance except
// that it extracts the status subresource applied configuration.
// Experimental!
func ExtractTemplateInstanceStatus(templateInstance *apitemplatev1.TemplateInstance, fieldManager string) (*TemplateInstanceApplyConfiguration, error) {
	return extractTemplateInstance(templateInstance, fieldManager, "status")
}

func extractTemplateInstance(templateInstance *apitemplatev1.TemplateInstance, fieldManager string, subresource string) (*TemplateInstanceApplyConfiguration, error) {
	b := &TemplateInstanceApplyConfiguration{}
	err := managedfields.ExtractInto(templateInstance, internal.Parser().Type("com.github.openshift.api.template.v1.TemplateInstance"), fieldManager, b, subresource)
	if err != nil {
		return nil, err
	}
	b.WithName(templateInstance.Name)
	b.WithNamespace(templateInstance.Namespace)

	b.WithKind("TemplateInstance")
	b.WithAPIVersion("template.openshift.io/v1")
	return b, nil
}

// WithKind sets the Kind field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Kind field is set to the value of the last call.
func (b *TemplateInstanceApplyConfiguration) WithKind(value string) *TemplateInstanceApplyConfiguration {
	b.Kind = &value
	return b
}

// WithAPIVersion sets the APIVersion field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the APIVersion field is set to the value of the last call.
func (b *TemplateInstanceApplyConfiguration) WithAPIVersion(value string) *TemplateInstanceApplyConfiguration {
	b.APIVersion = &value
	return b
}

// WithName sets the Name field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Name field is set to the value of the last call.
func (b *TemplateInstanceApplyConfiguration) WithName(value string) *TemplateInstanceApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	b.Name = &value
	return b
}

// WithGenerateName sets the GenerateName field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the GenerateName field is set to the value of the last call.
func (b *TemplateInstanceApplyConfiguration) WithGenerateName(value string) *TemplateInstanceApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	b.GenerateName = &value
	return b
}

// WithNamespace sets the Namespace field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Namespace field is set to the value of the last call.
func (b *TemplateInstanceApplyConfiguration) WithNamespace(value string) *TemplateInstanceApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	b.Namespace = &value
	return b
}

// WithUID sets the UID field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the UID field is set to the value of the last call.
func (b *TemplateInstanceApplyConfiguration) WithUID(value types.UID) *TemplateInstanceApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	b.UID = &value
	return b
}

// WithResourceVersion sets the ResourceVersion field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the ResourceVersion field is set to the value of the last call.
func (b *TemplateInstanceApplyConfiguration) WithResourceVersion(value string) *TemplateInstanceApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	b.ResourceVersion = &value
	return b
}

// WithGeneration sets the Generation field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Generation field is set to the value of the last call.
func (b *TemplateInstanceApplyConfiguration) WithGeneration(value int64) *TemplateInstanceApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	b.Generation = &value
	return b
}

// WithCreationTimestamp sets the CreationTimestamp field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the CreationTimestamp field is set to the value of the last call.
func (b *TemplateInstanceApplyConfiguration) WithCreationTimestamp(value metav1.Time) *TemplateInstanceApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	b.CreationTimestamp = &value
	return b
}

// WithDeletionTimestamp sets the DeletionTimestamp field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the DeletionTimestamp field is set to the value of the last call.
func (b *TemplateInstanceApplyConfiguration) WithDeletionTimestamp(value metav1.Time) *TemplateInstanceApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	b.DeletionTimestamp = &value
	return b
}

// WithDeletionGracePeriodSeconds sets the DeletionGracePeriodSeconds field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the DeletionGracePeriodSeconds field is set to the value of the last call.
func (b *TemplateInstanceApplyConfiguration) WithDeletionGracePeriodSeconds(value int64) *TemplateInstanceApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	b.DeletionGracePeriodSeconds = &value
	return b
}

// WithLabels puts the entries into the Labels field in the declarative configuration
// and returns the receiver, so that objects can be build by chaining "With" function invocations.
// If called multiple times, the entries provided by each call will be put on the Labels field,
// overwriting an existing map entries in Labels field with the same key.
func (b *TemplateInstanceApplyConfiguration) WithLabels(entries map[string]string) *TemplateInstanceApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	if b.Labels == nil && len(entries) > 0 {
		b.Labels = make(map[string]string, len(entries))
	}
	for k, v := range entries {
		b.Labels[k] = v
	}
	return b
}

// WithAnnotations puts the entries into the Annotations field in the declarative configuration
// and returns the receiver, so that objects can be build by chaining "With" function invocations.
// If called multiple times, the entries provided by each call will be put on the Annotations field,
// overwriting an existing map entries in Annotations field with the same key.
func (b *TemplateInstanceApplyConfiguration) WithAnnotations(entries map[string]string) *TemplateInstanceApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	if b.Annotations == nil && len(entries) > 0 {
		b.Annotations = make(map[string]string, len(entries))
	}
	for k, v := range entries {
		b.Annotations[k] = v
	}
	return b
}

// WithOwnerReferences adds the given value to the OwnerReferences field in the declarative configuration
// and returns the receiver, so that objects can be build by chaining "With" function invocations.
// If called multiple times, values provided by each call will be appended to the OwnerReferences field.
func (b *TemplateInstanceApplyConfiguration) WithOwnerReferences(values ...*v1.OwnerReferenceApplyConfiguration) *TemplateInstanceApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	for i := range values {
		if values[i] == nil {
			panic("nil value passed to WithOwnerReferences")
		}
		b.OwnerReferences = append(b.OwnerReferences, *values[i])
	}
	return b
}

// WithFinalizers adds the given value to the Finalizers field in the declarative configuration
// and returns the receiver, so that objects can be build by chaining "With" function invocations.
// If called multiple times, values provided by each call will be appended to the Finalizers field.
func (b *TemplateInstanceApplyConfiguration) WithFinalizers(values ...string) *TemplateInstanceApplyConfiguration {
	b.ensureObjectMetaApplyConfigurationExists()
	for i := range values {
		b.Finalizers = append(b.Finalizers, values[i])
	}
	return b
}

func (b *TemplateInstanceApplyConfiguration) ensureObjectMetaApplyConfigurationExists() {
	if b.ObjectMetaApplyConfiguration == nil {
		b.ObjectMetaApplyConfiguration = &v1.ObjectMetaApplyConfiguration{}
	}
}

// WithSpec sets the Spec field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Spec field is set to the value of the last call.
func (b *TemplateInstanceApplyConfiguration) WithSpec(value *TemplateInstanceSpecApplyConfiguration) *TemplateInstanceApplyConfiguration {
	b.Spec = value
	return b
}

// WithStatus sets the Status field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Status field is set to the value of the last call.
func (b *TemplateInstanceApplyConfiguration) WithStatus(value *TemplateInstanceStatusApplyConfiguration) *TemplateInstanceApplyConfiguration {
	b.Status = value
	return b
}

// GetName retrieves the value of the Name field in the declarative configuration.
func (b *TemplateInstanceApplyConfiguration) GetName() *string {
	b.ensureObjectMetaApplyConfigurationExists()
	return b.Name
}
